#region File Description
//-----------------------------------------------------------------------------------
// File : AsuraCustomMaterialProcessor.cs
//
// Date : June 14, 2008
// Version : 1.0
// Author : Pocol
//-----------------------------------------------------------------------------------
#endregion

#region Using Statements
using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Processors;
#endregion

namespace Asura
{
	[ContentProcessor(DisplayName="Material - Asura Material Proccesor")]
	public class AsuraMaterialProcessor : MaterialProcessor
	{
		//@VF[_̃t@C
		private string shaderFile = null;
		[DisplayName("Shader File")]
		[DefaultValue(null)]
		[Description("`ɎgpVF[_̃t@C")]
		public string ShaderFile
		{
			get { return shaderFile; }
			set { shaderFile = value; }
		}

		public override MaterialContent Process(MaterialContent input, ContentProcessorContext context)
		{
			//@VF[_t@Cꍇ
			if (shaderFile != null)
			{
				EffectMaterialContent customMaterial = new EffectMaterialContent();

				//@GtFNg̃t@C擾
				string effectFile = Path.GetFullPath(ShaderFile);
				customMaterial.Effect = new ExternalReference<EffectContent>(effectFile);

				BasicMaterialContent basicMaterial = (BasicMaterialContent)input;

				//@VF[_ɑp[^
				customMaterial.OpaqueData.Add("DiffuseColor", basicMaterial.DiffuseColor);
				customMaterial.OpaqueData.Add("SpecularColor", basicMaterial.SpecularColor);
				customMaterial.OpaqueData.Add("SpecularPower", basicMaterial.SpecularPower);
				customMaterial.OpaqueData.Add("EmissiveColor", basicMaterial.EmissiveColor);
				customMaterial.OpaqueData.Add("Alpha", basicMaterial.Alpha);

				//@eNX`Ƃ
				if (basicMaterial.Texture != null)
				{
					customMaterial.Textures.Add("DecalMap", basicMaterial.Texture);
					customMaterial.OpaqueData.Add("TextureEnabled", true);
				}

				return base.Process(customMaterial, context);
			}

			//@VF[_t@CȂꍇ
			else
			{
				return base.Process(input, context);
			}
		}

	}

}