#region File Description
//-----------------------------------------------------------------------------------
// File : AsuraCustomModelProcessor.cs
//
// Date : June 14, 2008
// Version : 1.0
// Author : Pocol
//-----------------------------------------------------------------------------------
#endregion

#region Using Statements
using System.ComponentModel;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Processors;
#endregion

namespace Asura
{
	[ContentProcessor(DisplayName="Model - Asura Model Processor")]
	public class AsuraModelProcessor : ModelProcessor
	{
		//@VF[_̃t@C
		private string shaderFile = null;
		[DisplayName("Shader File")]
		[DefaultValue(null)]
		[Description("`ɎgpVF[_̃t@C")]
		public string ShaderFile
		{
			get { return shaderFile; }
			set { shaderFile = value; }
		}

		protected override MaterialContent ConvertMaterial(MaterialContent material, ContentProcessorContext context)
		{
			OpaqueDataDictionary processorParameters = new OpaqueDataDictionary();
			
			//@p[^̒ǉ
			if ( shaderFile != null )
				processorParameters.Add("ShaderFile", shaderFile);

			return context.Convert<MaterialContent, MaterialContent>(
				material,
				"AsuraMaterialProcessor",
				processorParameters);
		}
	}
	
}