#region File Description
//-----------------------------------------------------------------------------------------------------
// File : AsuraPerformanceCounter.cs
//
// Desc : Asura Frame Per Second Counter
// Version : 1.0
// Author : Pocol
//-----------------------------------------------------------------------------------------------------
#endregion

#region Using Statements
//
// Using Statements
//
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
#endregion

namespace Asura
{
	/// <summary>
	/// FPSNX
	/// </summary>
	public class PerformanceCounter
	{
		#region Variables
		//
		// Variables
		//
		private float frameRate;
		private float updateInterval;
		private float timeSinceLastUpdate;
		private float frameCount;
		#endregion

		#region Properity
		//
		// Properity
		//

		/// <summary>
		/// FPS
		/// </summary>
		public float FrameRate
		{ get { return frameRate; } }

		/// <summary>
		/// XVԊu
		/// </summary>
		public float UpdateInterval
		{ 
			get { return updateInterval; }
			set { updateInterval = value; }
		}
		#endregion

		/// <summary>
		/// RXgN^
		/// </summary>
		public PerformanceCounter()
		{
			frameCount = 0;
			frameRate = 0;
			updateInterval = 0.5f;
			timeSinceLastUpdate = 0;
		}

		/// <summary>
		/// FPSXV
		/// </summary>
		/// <param name="gameTime">Provides a snapshot of timing values.</param>
		public void Update(GameTime gameTime)
		{
			float elapsed = (float)gameTime.ElapsedRealTime.TotalSeconds;
			frameCount++;
			timeSinceLastUpdate += elapsed;

			if (timeSinceLastUpdate > updateInterval)
			{
				frameRate = frameCount / timeSinceLastUpdate;
				frameCount = 0;
				timeSinceLastUpdate -= updateInterval;
			}
		
		}
	}
}