#region File Description
//--------------------------------------------------------------------------------------------------
// File : Game1.cs
//
// Date : Nov. 03, 2008
// Version : 1.0
// Author : Pocol
//--------------------------------------------------------------------------------------------------
#endregion

#region Using Statements
using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace VertexTextureFetchingFog
{
	/// <summary>
	/// This is the main type for your game
	/// </summary>
	public class Game1 : Microsoft.Xna.Framework.Game
	{
		#region Variables
		GraphicsDeviceManager graphics;
		SpriteBatch spriteBatch;

		//@fƃeNX`
		Model m_Model;
		Texture2D m_DecalTexture;

		//@JECg
		Vector3 m_CameraPosition;
		Vector3 m_LightPosition;

		//@s
		Matrix m_World;
		Matrix m_View;
		Matrix m_Projection;

		//@tHO֌W
		float m_FogStart = 2.5f;
		float m_FogEnd = 0.0f;
		Vector4 m_FogColor = Color.White.ToVector4();
		Vector4 m_BackColor = Color.CornflowerBlue.ToVector4();
		Vector2 m_FogTranslate = new Vector2(1.0f, 0.0f);
		Texture2D m_FogMap;

		//@FPSvp
		Asura.PerformanceCounter m_PerformanceCounter;

		//@tHg֌W
		SpriteFont m_SpriteFont;
		SpriteSortMode m_SpriteSortMode = SpriteSortMode.Deferred;
		SpriteBlendMode m_SpriteBlendMode = SpriteBlendMode.AlphaBlend;
		#endregion

		/// <summary>
		/// RXgN^
		/// </summary>
		public Game1()
		{
			graphics = new GraphicsDeviceManager(this);
			Content.RootDirectory = "Content";

			//@OFF
			graphics.SynchronizeWithVerticalRetrace = false;
			IsFixedTimeStep = false;

			//@A`GCAX̐ݒ
			graphics.PreparingDeviceSettings += new EventHandler<PreparingDeviceSettingsEventArgs>(graphics_PreparingDeviceSettings);

			//@VTFgSM3.0
			graphics.MinimumVertexShaderProfile = ShaderProfile.VS_3_0;
			graphics.MinimumPixelShaderProfile = ShaderProfile.PS_3_0;
		}

		/// <summary>
		/// A`GCAX̐ݒ
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		void graphics_PreparingDeviceSettings(object sender, PreparingDeviceSettingsEventArgs e)
		{
			PresentationParameters pp = e.GraphicsDeviceInformation.PresentationParameters;

			// 4xAA2xAAgȂgႤ
			GraphicsAdapter adapter = e.GraphicsDeviceInformation.Adapter;
			SurfaceFormat format = adapter.CurrentDisplayMode.Format;

			// gAÃ^CvɎg邩ׂ
			MultiSampleType[] multiSampleTypes = {
													 MultiSampleType.FourSamples,
													 MultiSampleType.TwoSamples
												 };

			foreach (MultiSampleType mst in multiSampleTypes)
			{
				int quality = 0;
				if (adapter.CheckDeviceMultiSampleType(DeviceType.Hardware, format, false, mst, out quality))
				{
					// ŏɌgp\AAݒ肷B
					pp.MultiSampleQuality = 0;
					pp.MultiSampleType = mst;
					break;
				}
			}
		}

		/// <summary>
		/// Allows the game to perform any initialization it needs to before starting to run.
		/// This is where it can query for any required services and load any non-graphic
		/// related content.  Calling base.Initialize will enumerate through any components
		/// and initialize them as well.
		/// </summary>
		protected override void Initialize()
		{
			// TODO: Add your initialization logic here

			base.Initialize();
		}

		/// <summary>
		/// tHOWZo
		/// </summary>
		/// <param name="start">tHOJn_</param>
		/// <param name="end">tHOI_</param>
		/// <returns>ZotHOW</returns>
		public Vector2 ComputeFogCoord(float start, float end)
		{
			return new Vector2(
				end / (end - start),
				-1.0f / (end - start)
				);
		}

		/// <summary>
		/// LoadContent will be called once per game and is the place to load
		/// all of your content.
		/// </summary>
		protected override void LoadContent()
		{
			// Create a new SpriteBatch, which can be used to draw textures.
			spriteBatch = new SpriteBatch(GraphicsDevice);

			// TODO: use this.Content to load your game content here

			//@FPSvp
			m_PerformanceCounter = new Asura.PerformanceCounter();

			//@Jʒu̐ݒ
			m_CameraPosition = new Vector3(30, 15, 30);

			//@ʒu̐ݒ
			m_LightPosition = new Vector3(100, 100, 100);

			//@s̐ݒ
			m_World = Matrix.Identity;
			m_View = Matrix.CreateLookAt(m_CameraPosition, Vector3.Zero, Vector3.Up);
			m_Projection = Matrix.CreatePerspectiveFieldOfView(MathHelper.PiOver4, GraphicsDevice.Viewport.AspectRatio, 0.01f, 1000.0f);

			//@t@C̓ǂݍݏ
			m_Model = Content.Load<Model>("Models/terrain");
			m_SpriteFont = Content.Load<SpriteFont>("Fonts/SpriteFont");
			m_DecalTexture = Content.Load<Texture2D>("Textures/colormap");
			m_FogMap = Content.Load<Texture2D>("Textures/FogMap");

			//@p[^]
			foreach (ModelMesh mesh in m_Model.Meshes)
			{
				foreach (Effect effect in mesh.Effects)
				{
					effect.Parameters["LightPosition"].SetValue(m_LightPosition);
					effect.Parameters["FogMap"].SetValue(m_FogMap);
					effect.Parameters["FogCoord"].SetValue(ComputeFogCoord(m_FogStart, m_FogEnd));
					effect.Parameters["FogColor"].SetValue(m_FogColor);
					effect.Parameters["FogTranslate"].SetValue(m_FogTranslate);
					effect.Parameters["DecalMap"].SetValue(m_DecalTexture);
				}
			}
		}

		/// <summary>
		/// UnloadContent will be called once per game and is the place to unload
		/// all content.
		/// </summary>
		protected override void UnloadContent()
		{
			// TODO: Unload any non ContentManager content here
		}

		/// <summary>
		/// Allows the game to run logic such as updating the world,
		/// checking for collisions, gathering input, and playing audio.
		/// </summary>
		/// <param name="gameTime">Provides a snapshot of timing values.</param>
		protected override void Update(GameTime gameTime)
		{
			// Allows the game to exit
			if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
				this.Exit();

			// TODO: Add your update logic here

			//@J
			KeyboardState keyState = Keyboard.GetState();
			if (keyState.IsKeyDown(Keys.Up)) 
			{ m_CameraPosition.Y += 0.05f; }
			if (keyState.IsKeyDown(Keys.Down)) 
			{ m_CameraPosition.Y -= 0.05f;}
			if (keyState.IsKeyDown(Keys.Left))
			{ m_CameraPosition.X -= 0.05f; }
			if (keyState.IsKeyDown(Keys.Right))
			{ m_CameraPosition.X += 0.05f; }
			if (keyState.IsKeyDown(Keys.Z))
			{ m_CameraPosition.Z += 0.05f; }
			if (keyState.IsKeyDown(Keys.X))
			{ m_CameraPosition.Z -= 0.05f; 	}

			//@r[sXV
			m_View = Matrix.CreateLookAt(m_CameraPosition, Vector3.Zero, Vector3.Up);

			//@tHO}bv𓮂
			m_FogTranslate.X += 0.05f * (gameTime.ElapsedGameTime.Milliseconds * 0.001f);
			m_FogTranslate.Y += 0.05f * (gameTime.ElapsedGameTime.Milliseconds * 0.001f);

			base.Update(gameTime);
		}

		/// <summary>
		/// f̕`
		/// </summary>
		/// <param name="model">`悵f</param>
		public void DrawModel(Model model)
		{
			Matrix[] transforms = new Matrix[model.Bones.Count];
			model.CopyAbsoluteBoneTransformsTo(transforms);

			foreach (ModelMesh mesh in model.Meshes)
			{
				foreach (Effect effect in mesh.Effects)
				{
					effect.Parameters["World"].SetValue(transforms[mesh.ParentBone.Index] * m_World);
					effect.Parameters["View"].SetValue(m_View);
					effect.Parameters["Projection"].SetValue(m_Projection);
					effect.Parameters["CameraPosition"].SetValue(m_CameraPosition);
					effect.Parameters["FogTranslate"].SetValue(m_FogTranslate);
				}
				mesh.Draw();
			}
		}

		/// <summary>
		/// This is called when the game should draw itself.
		/// </summary>
		/// <param name="gameTime">Provides a snapshot of timing values.</param>
		protected override void Draw(GameTime gameTime)
		{
			GraphicsDevice.Clear(Color.CornflowerBlue);

			// TODO: Add your drawing code here

			//@nʂ`
			DrawModel(m_Model);

			//@FPS\
			string m_Format = string.Format("FPS : {0:###.00}", m_PerformanceCounter.FrameRate);
			spriteBatch.Begin(m_SpriteBlendMode, m_SpriteSortMode, SaveStateMode.SaveState);
			spriteBatch.DrawString(m_SpriteFont, m_Format, new Vector2(5, 5), Color.White);
			spriteBatch.End();

			//@FPSXV
			m_PerformanceCounter.Update(gameTime);

			base.Draw(gameTime);
		}
	}
}
